---
title: Get an OAuth2 client scopes restriction
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > OAuth2 Client Public
---

# Get an OAuth2 client scopes restriction{% #get-an-oauth2-client-scopes-restriction %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                             |
| ----------------- | ---------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/oauth2/clients/{client_uuid}/scopes_restriction      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction |

### Overview

Get the scopes restriction configured for the OAuth2 client. This endpoint requires the `org_authorized_apps_read` permission.

### Arguments

#### Path Parameters

| Name                          | Type   | Description                |
| ----------------------------- | ------ | -------------------------- |
| client_uuid [*required*] | string | UUID of the OAuth2 client. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response payload describing the scopes restriction of an OAuth2 client.

| Parent field       | Field                                        | Type     | Description                                                                                                                                       |
| ------------------ | -------------------------------------------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------- |
|                    | data [*required*]                       | object   | Data object of an OAuth2 client scopes restriction response.                                                                                      |
| data               | attributes [*required*]                 | object   | Attributes of an OAuth2 client scopes restriction.                                                                                                |
| attributes         | required_permission_scopes [*required*] | [string] | Permission scopes automatically required for this client (for example, mobile-app permission scopes). Returns `null` when no scopes are required. |
| attributes         | scopes_restriction [*required*]         | object   | Allowlist of OIDC and permission scopes enforced for the OAuth2 client.                                                                           |
| scopes_restriction | oidc_scopes [*required*]                | [string] | OIDC scopes the client is restricted to.                                                                                                          |
| scopes_restriction | permission_scopes [*required*]          | [string] | Datadog permission scopes the client is restricted to.                                                                                            |
| data               | id [*required*]                         | uuid     | UUID of the OAuth2 client this restriction applies to.                                                                                            |
| data               | type [*required*]                       | enum     | JSON:API resource type for an OAuth2 client scopes restriction. Allowed enum values: `scopes_restriction`                                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "required_permission_scopes": [
        "mobile_app_access"
      ],
      "scopes_restriction": {
        "oidc_scopes": [
          "openid",
          "email"
        ],
        "permission_scopes": [
          "dashboards_read",
          "metrics_read"
        ]
      }
    },
    "id": "fafa8e1c-36a5-11f0-a83d-da7ad0900001",
    "type": "scopes_restriction"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export client_uuid="fafa8e1c-36a5-11f0-a83d-da7ad0900001" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/oauth2/clients/${client_uuid}/scopes_restriction" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get an OAuth2 client scopes restriction returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.o_auth2_client_public_api import OAuth2ClientPublicApi
from uuid import UUID

configuration = Configuration()
configuration.unstable_operations["get_scopes_restriction"] = True
with ApiClient(configuration) as api_client:
    api_instance = OAuth2ClientPublicApi(api_client)
    response = api_instance.get_scopes_restriction(
        client_uuid=UUID("fafa8e1c-36a5-11f0-a83d-da7ad0900001"),
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Get an OAuth2 client scopes restriction returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_scopes_restriction".to_sym] = true
end
api_instance = DatadogAPIClient::V2::OAuth2ClientPublicAPI.new
p api_instance.get_scopes_restriction("fafa8e1c-36a5-11f0-a83d-da7ad0900001")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Get an OAuth2 client scopes restriction returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetScopesRestriction", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewOAuth2ClientPublicApi(apiClient)
	resp, r, err := api.GetScopesRestriction(ctx, uuid.MustParse("fafa8e1c-36a5-11f0-a83d-da7ad0900001"))

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `OAuth2ClientPublicApi.GetScopesRestriction`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `OAuth2ClientPublicApi.GetScopesRestriction`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Get an OAuth2 client scopes restriction returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.OAuth2ClientPublicApi;
import com.datadog.api.client.v2.model.OAuthScopesRestrictionResponse;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getScopesRestriction", true);
    OAuth2ClientPublicApi apiInstance = new OAuth2ClientPublicApi(defaultClient);

    try {
      OAuthScopesRestrictionResponse result =
          apiInstance.getScopesRestriction(UUID.fromString("fafa8e1c-36a5-11f0-a83d-da7ad0900001"));
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OAuth2ClientPublicApi#getScopesRestriction");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Get an OAuth2 client scopes restriction returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_o_auth2_client_public::OAuth2ClientPublicAPI;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetScopesRestriction", true);
    let api = OAuth2ClientPublicAPI::with_config(configuration);
    let resp = api
        .get_scopes_restriction(
            Uuid::parse_str("fafa8e1c-36a5-11f0-a83d-da7ad0900001").expect("invalid UUID"),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Get an OAuth2 client scopes restriction returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getScopesRestriction"] = true;
const apiInstance = new v2.OAuth2ClientPublicApi(configuration);

const params: v2.OAuth2ClientPublicApiGetScopesRestrictionRequest = {
  clientUuid: "fafa8e1c-36a5-11f0-a83d-da7ad0900001",
};

apiInstance
  .getScopesRestriction(params)
  .then((data: v2.OAuthScopesRestrictionResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
